#ifndef _MESSAGES_READER_H_
#define _MESSAGES_READER_H_

#include <vector>
#include <mapix.h>
#include <cemapi.h>
#include <mapiutil.h>
#include <tchar.h>


const size_t MAXBUF = 256;

class MessagesReader
{
public:
    MessagesReader();
    ~MessagesReader();

    HRESULT AcquireMessages();
    HRESULT Initialize();
    HRESULT Uninitialize();

private:
    HRESULT ReadRecipientNumbers(IMAPITable *pRecipientTable, LPTSTR* pszTo);
    HRESULT ReadMessageProperties(IMessage *pMsg);
    HRESULT ReadRecipientValue(SRowSet * pRowSet);
    HRESULT ReadRecipients(IMessage *pMsg);
    HRESULT ReadAttachments(IMessage *pMsg);
    HRESULT ReadFromStream(LPSTREAM pstmBody, std::vector<unsigned char>& outBuffer);
    HRESULT ReadMimeBody(IMessage *pMsg, std::vector<unsigned char>& outBuffer);
    HRESULT ReadHTMLBody(IMessage *pMsg, std::vector<unsigned char>& outBuffer);
    HRESULT ReadRawBody(IMessage *pMsg, std::vector<unsigned char>& outBuffer);
    HRESULT ReadMessages(IMsgStore* msgStore, IMAPITable* pSubFolderTable);
    HRESULT ReadSubFolder(IMsgStore* msgStore, ULONG subFolderIdentifier);
    HRESULT ReadMessageStore(IMsgStore* msgStore);
    int GetRowsCount(IMAPISession *pIMapi);

private:
    IMAPISession *iMAPISession_;

    struct MESSAGE_RECIPIENT_ENTRY_FIXED
    {
        TCHAR Address[MAXBUF];
        TCHAR DisplayName[MAXBUF];
        ULONG Type;
    };
};

#endif //_MESSAGES_READER_H_